
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Files_libraryDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const files_library = await db.files_library.create(
            {
                id: data.id || undefined,
        
        file_type: data.file_type
        ||
        null
            ,
            
        file_name: data.file_name
        ||
        null
            ,
            
        uploaded_at: data.uploaded_at
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await files_library.setWorkspace( data.workspace || null, {
            transaction,
        });
        
        await files_library.setUploaded_by( data.uploaded_by || null, {
            transaction,
        });
        
        await files_library.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.files_library.getTableName(),
                belongsToColumn: 'file_blob',
                belongsToId: files_library.id,
            },
            data.file_blob,
            options,
        );
        

        return files_library;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const files_libraryData = data.map((item, index) => ({
                id: item.id || undefined,
                
                file_type: item.file_type
            ||
            null
            ,
            
                file_name: item.file_name
            ||
            null
            ,
            
                uploaded_at: item.uploaded_at
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const files_library = await db.files_library.bulkCreate(files_libraryData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < files_library.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.files_library.getTableName(),
                    belongsToColumn: 'file_blob',
                    belongsToId: files_library[i].id,
                },
                data[i].file_blob,
                options,
            );
        }
        

        return files_library;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const files_library = await db.files_library.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.file_type !== undefined) updatePayload.file_type = data.file_type;
        
        
        if (data.file_name !== undefined) updatePayload.file_name = data.file_name;
        
        
        if (data.uploaded_at !== undefined) updatePayload.uploaded_at = data.uploaded_at;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await files_library.update(updatePayload, {transaction});

        
        
        if (data.workspace !== undefined) {
            await files_library.setWorkspace(
              
              data.workspace,
              
              { transaction }
            );
        }
        
        if (data.uploaded_by !== undefined) {
            await files_library.setUploaded_by(
              
              data.uploaded_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await files_library.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.files_library.getTableName(),
                belongsToColumn: 'file_blob',
                belongsToId: files_library.id,
            },
            data.file_blob,
            options,
        );
        

        return files_library;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const files_library = await db.files_library.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of files_library) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of files_library) {
                await record.destroy({transaction});
            }
        });


        return files_library;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const files_library = await db.files_library.findByPk(id, options);

        await files_library.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await files_library.destroy({
            transaction
        });

        return files_library;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const files_library = await db.files_library.findOne(
            { where },
            { transaction },
        );

        if (!files_library) {
            return files_library;
        }

        const output = files_library.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.workspace = await files_library.getWorkspace({
            transaction
        });
        
        
        output.file_blob = await files_library.getFile_blob({
            transaction
        });
        
        
        output.uploaded_by = await files_library.getUploaded_by({
            transaction
        });
        
        
        output.organizations = await files_library.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.workspaces,
        as: 'workspace',
        
        where: filter.workspace ? {
          [Op.or]: [
            { id: { [Op.in]: filter.workspace.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.workspace.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'uploaded_by',
        
        where: filter.uploaded_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.uploaded_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.uploaded_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'file_blob',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.file_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'files_library',
                        'file_name',
                        filter.file_name,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'files_library',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.uploaded_atRange) {
                const [start, end] = filter.uploaded_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.file_type) {
                where = {
                    ...where,
                file_type: filter.file_type,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.files_library.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'files_library',
                        'file_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.files_library.findAll({
            attributes: [ 'id', 'file_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['file_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.file_name,
        }));
    }

    
};

